declare function getEnvironmentVariables(): Bun.Env | {
    [index: string]: string;
};
interface EnvironmentVariableOptions {
    /**
     * Strict checking. Will throw error if the variable name is non-existent.
     *
     * @defaultValue `false`
     */
    strict?: boolean;
}
/**
 * Possible value types of the environment variable.
 */
type EnvironmentVariableValue = boolean | number | string;
declare function hasEnvironmentVariable(variable: string): boolean;
declare function getEnvironmentVariable<ValueType extends EnvironmentVariableValue>(_variable: string, _options?: {
    strict?: false;
}): ValueType | undefined;
declare function getEnvironmentVariable<ValueType extends EnvironmentVariableValue>(_variable: string, _options: {
    strict: true;
}): ValueType;
declare function setEnvironmentVariable(name: string, value: EnvironmentVariableValue): void;
declare function deleteEnvironmentVariable(name: string, options?: EnvironmentVariableOptions): void;

export { EnvironmentVariableOptions, EnvironmentVariableValue, deleteEnvironmentVariable, getEnvironmentVariable, getEnvironmentVariables, hasEnvironmentVariable, setEnvironmentVariable };
